#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
import commands
import os
import os.path
import pygtk
import gtk

__author__="tmin"
__date__ ="$2010/08/28 13:42:04$"

#インストールコマンド群
installCommands=(
("gksudo add-apt-repository ppa:khf03353/ppa-kaorin","gksudo apt-get update",'gksudo "apt-get -y install mikutube"'),   #install mikutube
("gksudo add-apt-repository ppa:khf03353/ppa-kaorin","gksudo apt-get update",'gksudo "apt-get -y install mikukabe"'),    #install mikukabe
("gksudo apt-get update",'gksudo "apt-get -y install macopix-gtk2"',"wget http://mangareview.up.seesaa.net/image/Dancing-Miku0.6.tar.gz http://dl.dropbox.com/u/1336728/kioshiki.tar.gz","tar xvf Dancing-Miku0.6.tar.gz","tar xvf kioshiki.tar.gz","mkdir -p ~/.macopix/pixmap&& mkdir -p ~/.macopix/sound","mv Dancing-Miku0.6/*mcpx Dancing-Miku0.6/*menu ~/.macopix&& mv Dancing-Miku0.6/*png ~/.macopix/pixmap","mv kioshiki/*mcpx kioshiki/*menu ~/.macopix&& mv kioshiki/*png ~/.macopix/pixmap"),     #install macopix & DL kioshiki&DancingMiku
("gksudo apt-get update",'gksudo "apt-get -y install audacious"',"wget http://mangareview.up.seesaa.net/image/mikumiku001.tar.gz","wget http://mangareview.up.seesaa.net/image/mikumiku_00220.tar.gz","wget http://mangareview.up.seesaa.net/image/mikumiku_003.tar.gz"), #install audacious &DL thema
("gksudo add-apt-repository ppa:japanese-testers/ppa","gksudo apt-get update",'gksudo "apt-get -y install ibus-mozc mozc-server mozc-utils-gui scim-mozc"',"wget http://blog-imgs-31-origin.fc2.com/m/y/p/mypace75/1p4s6n.png","wget http://blog-imgs-31-origin.fc2.com/m/y/p/mypace75/hachune-3.png","wget http://blog-imgs-31-origin.fc2.com/m/y/p/mypace75/hachune-2.png","wget http://blog-imgs-31-origin.fc2.com/m/y/p/mypace75/hachune-1.png","gksudo mv /usr/share/ibus-mozc/product_icon.png /usr/share/ibus-mozc/product_icon2.png","gksudo mv /usr/share/ibus-mozc/tool.png /usr/share/ibus-mozc/tool2.png","gksudo mv 1p4s6n.png tool.png","gksudo mv tool.png /usr/share/ibus-mozc","gksudo mv *png /usr/share/ibus-mozc","gksudo mv /usr/share/ibus-mozc/hachune-1.png /usr/share/ibus-mozc/product_icon.png"),  #install mozc&dl icon
("wget http://github.com/downloads/wasabili/GSoundThemeManager/gstmanager_1.1.0b1-0ubuntu1_all.deb",'gksudo "dpkg -i gstmanager_1.1.0b1-0ubuntu1_all.deb"'), #install gstmanager
("gksudo add-apt-repository ppa:khf03353/ppa-kaorin","gksudo apt-get update",'gksudo "apt-get -y install mikutter"'), #install mikutter
("wget http://dl.dropbox.com/u/1336728/moesetup.tar.gz","wget http://mangareview.up.seesaa.net/image/mikumiku2.tar.gz","wget http://dl.dropbox.com/u/1336728/mikunchu.tar.gz","wget http://dl.dropbox.com/u/1336728/mikunchu02.tar.gz","wget http://dl.dropbox.com/u/1336728/mikunchu03.tar.gz","wget http://moebuntu.web.fc2.com/img/parts/Moe-BlueGreen.tar.gz","tar xvzf moesetup.tar.gz","./moesetup.py"), #install moesetup&dl thema soundthema plymouthdthema
    )


class MikunchApp:

    def __init__(self):

        #Set the Glade file
        self.gladefile = "mikunchu.ui"
        self.wTree = gtk.Builder()
        self.wTree.add_from_file(os.path.dirname(os.path.abspath(__file__)) + "/"+self.gladefile)
        #Create our dictionay and connect it
        dic = {
                "on_btCansel_clicked" : self.on_btnCancel_clicked,
                "on_btOK_clicked" : self.on_btnOK_clicked,
                "on_TopLevel_destroy" : self.on_TopLevel_destroy }
        self.chkmikutube = self.wTree.get_object("chkmikutube")
        self.chkmikukabe = self.wTree.get_object("chkmikukabe")
        self.chkmacopix = self.wTree.get_object("chkmacopix")
        self.chkaudacious = self.wTree.get_object("chkaudacious")
        self.chkibusmozc = self.wTree.get_object("chkibusmozc")
        self.chkgstmanager = self.wTree.get_object("chkgstmanager")
        self.chkmikutter = self.wTree.get_object("chkmikutter")
        self.chkmoesetup = self.wTree.get_object("chkmoesetup")
        self.wTree.connect_signals(dic)
        
        self.mainWindow = self.wTree.get_object ("TopLevel")
        self.mainWindow.show_all()

    def on_TopLevel_destroy(self, widget):
        #ウィンドウを閉じてアプリケーションを終了する
        gtk.main_quit()

    def on_btnOK_clicked(self,widget):
        #適用を行ってアプリケーションを終了する
        if self.chkmikutube.get_active() == True:
            #install mikutube
            for cmd in installCommands[0]:
                self.execCommand(cmd)
        if self.chkmikukabe.get_active() == True:
            #install mikukabe
            for cmd in installCommands[1]:
                self.execCommand(cmd)
        if self.chkmacopix.get_active() == True:
            #install macopix
            for cmd in installCommands[2]:
                self.execCommand(cmd)
        if self.chkaudacious.get_active() == True:
            #install audacious
            for cmd in installCommands[3]:
                self.execCommand(cmd)
        if self.chkibusmozc.get_active() == True:
            #install mozc
            for cmd in installCommands[4]:
                self.execCommand(cmd)
        if self.chkgstmanager.get_active() == True:
            #install gstmanager
            for cmd in installCommands[5]:
                self.execCommand(cmd)
        if self.chkmikutter.get_active() == True:
            #install mikutter
            for cmd in installCommands[6]:
                self.execCommand(cmd)
        if self.chkmoesetup.get_active() == True:
            #install moesetup
            for cmd in installCommands[7]:
                self.execCommand(cmd)
        
        #ウィンドウを閉じてアプリケーションを終了する
        gtk.main_quit()

    def on_btnCancel_clicked(self,widget):
        #ウィンドウを閉じてアプリケーションを終了する
        gtk.main_quit()
    def execCommand(self,command):
        print command   #受け渡されたコマンドのデバッグ用プリント
        ret = commands.getoutput(command)
        print ret             #実行結果のデバッグ用プリント
        return ret

if __name__ == "__main__":
    MikunchApp()
    gtk.main()
